// Soubor DELEG.CS
// Ukazujue pouit delegt
// Deklaruje delegt Fce a pouije ho jako parametr metody 
// Tabulka() , je tabeluje zadanou matematickou funkci

using System;

public delegate double Fce(double x);

class Tabelace
{
	void Tabulka(Fce f, double od, double @do, double krok)
	{
		Console.WriteLine("x     f(x)");
		for(double x = od; x <= @do; x += krok)
			Console.WriteLine("{0:F1}   {1:F5}", x, f(x));
	}
	static void Main(string[] args)
	{
		Tabelace t = new Tabelace();
		t.Tabulka(new Fce(Math.Sin), 0, 1, 0.1);
	}
}
