// Soubor Matika.cs
// Ukazuje pouit metody s promnnm potem parametr


public class Matika
{
	// Prohod hodnoty parametr
	public static int max(params int[] data)	 
	{
		// Nelze potat maximum z nieho
		if(data.Length == 0) throw new System.ArgumentException(); 
		int s = data[0];
		foreach(int i in data) if(i > s) s = i;
		return s;
	}
}

class Program
{
	public static void Main()		
	{								
		// Metodu max() lze vlat s libovolnm potem parametr
		int a = Matika.max(5,88,-9,65);
		System.Console.WriteLine("max = {0}", a);
		int[] A = {99,1,5,9,55,4,2,6};
		// Metod max() lze tak pedat pole typu int
		System.Console.WriteLine("max = {0}", Matika.max(A));
	}

}
