// Soubor BOD.CS
// Ukazuje deklaraci a pouit vlastnost

using System;

public class Bod
{
	private double x, y;
	public Bod(double _x, double _y)			// Konstruktor
	{
		x = _x; y = _y;
	}
	public double X								// Vlastnost X
	{
		set { x = value; }
		get { return x; }
	}
	public double Y								// Vlastnost Y
	{
		set { y = value; }
		get { return y; }
	}
	public double R								// Vzdlenost od plu
	{
		get { return Math.Sqrt(x*x+y*y); }
	}
	public double F							// Polrn hel
	{
		get { return Math.Atan2(y,x); }
	}
}

public class Program
{
	public static void Main()
	{	// Pouit vlastnost
		Bod b = new Bod(1, 1);
		Console.WriteLine("Bod B(" + b.X + ", " + b.Y + ") m polrn souadnice " + b.R + ", " + b.F);
		b.X = 3; b.Y = 4;	
		Console.WriteLine("Bod B(" + b.X + ", " + b.Y + ") m polrn souadnice " + b.R + ", " + b.F);
	}
}