// Soubor VYP.CS
// Ukazuje deklaarci a pouit rozhran


using System;

public interface IVypisovac					// Deklarace rozhran
{
	void Vypi();
}

public class Stav: IVypisovac			// Tda implementujc rozhran
{
	public virtual void Vypi()
	{
		Console.WriteLine("Vypisuji stav ");
	}
} 

public class Sestava: IVypisovac		// pln jin tda implementujc tot rozhran
{
	public virtual void Vypi()
	{
		Console.WriteLine("Vypisuji sestavu ");
	}
} 

public class Program
{
	public static void VypiTo(IVypisovac x)	// Oekv instance rozhran
	{
		x.Vypi();
	}
	
	public static void Main()
	{
		Sestava sest = new Sestava();
		Stav st = new Stav();
		VypiTo(st);
		VypiTo(sest);
	}
}
