// Soubor Sestava3.cs
// Ukazuje pedefinovn nevirtulnch metod pi reimplementaci
// rozhran a jejich voln 

using System;

public interface IVypisovac
{
	void Vypi();
}

public class Sestava: IVypisovac
{
	public void Vypi()	// Implementuje metodu rozhran jako nevirtuln		
	{
		Console.WriteLine("Vypisuji sestavu pro rozhran");
	}
} 

public class KritickSestava: Sestava, IVypisovac
{
	new public void Vypi() 
		// Pedefinuje nevirtuln metodu z pedka 
	{
		Console.WriteLine("Vypisuji kritickou sestavu ");
	}
}

	public class Program
	{
		public static void Main()
		{
			// Dva odkazy na rozhran, jeden obsahuje odkaz pedka, druh na potomka
			IVypisovac iv = new Sestava();
			IVypisovac iw = new KritickSestava();
			iv.Vypi();		// Vol metodu pedka
			iw.Vypi();		// Nyn vol metodu potomka
			KritickSestava ks = (KritickSestava)iw;
			ks.Vypi();		// Vol metodu potomka
		}
	}
