// Soubor NANIC.CS
// Ukazuje deklaraci a pouit vlastnho atributu
// Main() je ve td Pokus

using System;
using System.Reflection;
using MojeAtributy;

namespace MojeAtributy
{
	// Tda atributu
	[AttributeUsage(AttributeTargets.All)]	// Pro vechny cle
	public class NaNicAttribute: System.Attribute
	{
		public string Proslov;		// Obsahuje znakov etzec
		public NaNicAttribute(string s){Proslov = s;}	// Konstruktory
		public NaNicAttribute(){Proslov = "Je to na houby";}
		public string Text			// Vlastnost, zpstupujc znakov etzec
		{
			get{return Proslov;}
			set{Proslov = value;}
		}
	}
}

//[MojeAtributy.NaNic("SkoDoZdi")]

public class Y
{
	// Zjist atributy svho parametru
	public void f(X x)
	{
		Console.WriteLine("Atributy parametr metody Y.f:");
		ParameterInfo[] pinf = typeof(X).GetMethod("f").GetParameters();
		object[] at = pinf[0].GetCustomAttributes(true);
		foreach(Attribute a in at)Console.WriteLine(a);
	}
}

public class X
{
	// Metoda f() pipoj ke td parametr a ped ho dl
	public void f([MojeAtributy.NaNic()] X x)
	{
		Y y = new Y();
		y.f(x);
	}

}


// Pouit atribut v deklaraci tdy
// Konstruktor vype vechny atributy (nikoli vak pseudoatributy)
// a u atributu NaNic tak jeho etzec Proslov
[NaNic("Na velmi mlo"), Serializable, Obsolete]
public class NjakTda
{
	public NjakTda()
	{
		Type t = typeof(NjakTda);
		object[] atr = t.GetCustomAttributes(false);
		Console.WriteLine("Seznam atribut tdy NjakTda:");
		foreach(Attribute a in atr)
		{
			Console.WriteLine(a.GetType());
			if(a.GetType() == typeof(MojeAtributy.NaNicAttribute))
				Console.WriteLine(((MojeAtributy.NaNicAttribute)a).Text);
		}
	}

}

public class Pokus
{
	public static void Main()
	{
		X xx = new X();
		xx.f(xx);
		NjakTda nt = new NjakTda();
	}
}
