// Soubor DELKA.CS
// Ukazuje pouit pkazu foreach pro vpis vech prvk pole,
// dvourozmrnho pole a fronty
// Pi vkldn prvk do fronty a pi vyjmn se pouije 
// balen (boxing, unboxing)

using System;

class Tabelace
{
		public static void VpisPole(double [] pole)
	{
		Console.WriteLine("Vypisuji pole:");
		foreach(int i in pole)
			System.Console.WriteLine(i);
	}

	public static void VypiFrontu(System.Collections.Queue fronta)
	{
		Console.WriteLine("Vypisuji frontu:");
		foreach(int i in fronta)Console.WriteLine(i);
	}

	public static void VpisDvourozmrnhoPole(int [,] pole)
	{
		Console.WriteLine("Vypisuji dvourozmrn pole:");
		foreach(int i in pole) Console.WriteLine(i);
	}
	
	static void Main()
	{	
		int [,] xx = new int[2,2] {{1,2},{3,4}};
		double [] p = new double[5] {1,2,3,4,5};
		System.Collections.Queue fronta = new System.Collections.Queue();

		for(int i = 0; i < 5; i++)fronta.Enqueue(i);
		
		VpisPole(p);
		VpisDvourozmrnhoPole(xx);
		VypiFrontu(fronta);
	}
}
