// Soubor KLON.CS
// Ukazuje klonovn (vytvoen hlubok kopie)
// Tda seka obsahuje dva Body -
// pesnji dv reference na instance tdy Bod. 
// Metoda Clone vytvo hlubokou kopii, take po zmn 
// souadnic jednoho z koncovch bod klonu se nezmn pvodn seka

using System;

public abstract class GO: ICloneable
{
	public abstract object Clone();
	public abstract void Nakresli();
}

class Bod: GO
{
	int x, y;
	public override object Clone()
	{
		return this.MemberwiseClone();
	}
	public Bod(int xx, int yy){x = xx; y = yy;}
	public override void Nakresli()
	{
		Console.WriteLine("Kreslm bod (" + x + ", " + y +")");
	}
}

class seka: GO
{
	private Bod A, B;
	public override object Clone()
	{
		seka r = (seka)this.MemberwiseClone();
		r.A = (Bod)A.Clone();
		r.B = (Bod)B.Clone();
		return r;
	}
	public seka(int x1, int y1, int x2, int y2)
	{
		A = new Bod(x1, y1);
		B = new Bod(x2, y2);
	}
	public Bod Potek		// Vlastnost zpstupujc poten bod seky
	{
		set{A = value;}
		get{return A;}
	}
	public Bod Konec		// Vlastnost zpstupujc koncov bod seky
	{
		set{B = value;}
		get{return B;}
	}
	public override void  Nakresli()
	{
		Console.WriteLine("Kreslm seku s tmito krajnmi body:");
		A.Nakresli();
		B.Nakresli();
	}
}

class Program
{
	public static void Main()
	{
		seka u1 = new seka(1,2,3,4);
		seka u2 = (seka)u1.Clone();
		u2.Konec = new Bod(8,9);
		u1.Nakresli();
		u2.Nakresli();
	}
}
