// Soubor ENUMER.CS
// Ukazuje pouit enumertoru
// k "nakreslen" vech grafickch objekt
// uloench v instanci tdy ArrayList
//
// Tdy GO, Bod a seka jsou prakticky stejn
// jako v pedchozm pkladu, li se pouze funcke Main()

using System;

public abstract class GO: ICloneable
{
	public abstract object Clone();
	public abstract void Nakresli();
}

class Bod: GO
{
	int x, y;
	public override object Clone()
	{
		return this.MemberwiseClone();
	}
	public Bod(int xx, int yy){x = xx; y = yy;}
	public override void Nakresli()
	{
		Console.WriteLine("Kreslm bod (" + x + ", " + y +")");
	}
}

class seka: GO
{
	private Bod A, B;
	public override object Clone()
	{
		seka r = (seka)this.MemberwiseClone();
		r.A = (Bod)A.Clone();
		r.B = (Bod)B.Clone();
		return r;
	}
	public seka(int x1, int y1, int x2, int y2)
	{
		A = new Bod(x1, y1);
		B = new Bod(x2, y2);
	}
	public Bod Potek		// Vlastnost zpstupujc poten bod seky
	{
		set{A = value;}
		get{return A;}
	}
	public Bod Konec		// Vlastnost zpstupujc koncov bod seky
	{
		set{B = value;}
		get{return B;}
	}
	public override void  Nakresli()
	{
		Console.WriteLine("Kreslm seku s tmito krajnmi body:");
		A.Nakresli();
		B.Nakresli();
		Console.WriteLine("seka nakreslena");
	}
}

class Program
{
	public static void Main()
	{
		// Vytvome kontejner a ulome do nj njak grafick objekty
		System.Collections.ArrayList obrzek = new System.Collections.ArrayList();
		obrzek.Add(new Bod(1,5));
		obrzek.Add(new seka(1,2,4,5));
		obrzek.Add(new Bod(9,8));

		// vypeme ve
		System.Collections.IEnumerator e = obrzek.GetEnumerator();
		while(e.MoveNext())
		{
			GO go = (GO)e.Current;
			go.Nakresli();
		}
		
		/* Nsledujc pkaz znamen tot co pedchoz deklarace 
		  a cyklus:
		
		foreach(GO go in obrzek) go.Nakresli();
		*/
	}
}
