// Soubor PROGRAM.CS
// pouit reflexe
// Dostane z pkazov dky jmno seskupen,
// vezme z nho jedinou tdu, vype info
// o slokch, vytvo instanci a zavol jej metodu
// 
// Peklad: csc program.cs
// Nen teba parametr /r:, protoe na seskupen
// s knihovnou se zde ve zdrojovm textu neodkazuje
//
// Spustme pkazem: program testik.dll

using System;
using System.Reflection;
class Program
{
	public static void Main(string[] s)
	{
		// Console.WriteLine("Jedeme");
		try
		{
			// Informace o seskupen
			Assembly a = Assembly.LoadFrom(s[0]);

			// Pehled typ definovanch v seskupen (vme, e je jen 1)
			Type[] t = a.GetTypes();

			// Informace o slokch
			MemberInfo[] mi = t[0].GetMembers();
			foreach(MemberInfo m in mi) Console.WriteLine(m);
		
			// Vytvome instanci neznm tdy (znme tdu Type, kter ji popisuje)
			object obj = Activator.CreateInstance(t[0], new object[]{1});

			// Informace o potebn metod (znme jej jmno)
			MethodInfo mti = t[0].GetMethod("Vypi");

			// Voln metody
			mti.Invoke(obj, null);
		}
		catch(Exception e)
		{
			Console.WriteLine(e.StackTrace);
		}
	}
}