// Soubor OKNO.CS

using System;
using System.Windows.Forms;

public class Okno1 : System.Windows.Forms.Form
{
	private string zatek = "A ije ...";		// Zatek npisu
	private string konec = "... ale za sv!";	// Konec npisu
	private bool jeToZatek = true;
	private OknoNov no = new OknoNov();		
							
	private Button tlatko;			// Pepnn sti npisu
	private Label npis;
	private MainMenu Nabdka;			// Nabdka jako celek
	private MenuItem menuNpis;			// Poloka Npis
	private MenuItem menuNov;			// Poloka Npis | Nov
	private MenuItem menuSep;			// Separtor
	private MenuItem menuKonec;			// Poloka Npis | Konec
	private MenuItem menuNpovda;			// poloka Npovda
	private MenuItem menuOProgramu;			// Poloka Npovda | O programu

	public Okno1()
	{
		InitializeComponent();
		zobraz();
	}

	protected override void Dispose( bool disposing )
	{
		base.Dispose( disposing );
	}
	#region Windows Form Designer generated code
	private void InitializeComponent()
	{
		npis = new Label();
		tlatko = new Button();
		Nabdka = new MainMenu();
		menuNpis = new MenuItem();
		menuNov = new MenuItem();
		menuSep = new MenuItem();
		menuKonec = new MenuItem();
		menuNpovda = new MenuItem();
		menuOProgramu = new MenuItem();
		SuspendLayout();
		// 
		// npis
		// 
		npis.Font = new System.Drawing.Font("Times New Roman", 18F, 
			System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point);
		npis.Location = new System.Drawing.Point(0, 40);
		npis.Size = new System.Drawing.Size(416, 48);
		npis.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
		// 
		// tlatko
		// 
		tlatko.Location = new System.Drawing.Point(280, 136);
		tlatko.Size = new System.Drawing.Size(128, 24);
		tlatko.Text = "Dokonen";
		tlatko.Click += new System.EventHandler(tlatko_Click);
		// 
		// Nabdka
		// 
		Nabdka.MenuItems.AddRange(new MenuItem[]{menuNpis, menuNpovda});
		// 
		// menuNpis
		// 
		menuNpis.MenuItems.AddRange(new MenuItem[] {menuNov, menuSep, menuKonec});
		menuNpis.Text = "Npis";
		// 
		// menuNov
		// 
		menuNov.Index = 0;
		menuNov.Text = "Nov";
		menuNov.Click += new System.EventHandler(this.menuNov_Click);
		// 
		// menuSep
		// 
		menuSep.Index = 1;
		menuSep.Text = "-";
		// 
		// menuKonec
		// 
		menuKonec.Text = "Konec";
		menuKonec.Click += new System.EventHandler(menuKonec_Click);
		// 
		// menuNpovda
		// 
		menuNpovda.MenuItems.AddRange(new MenuItem[] {menuOProgramu});
		menuNpovda.Text = "Npovda";
		// 
		// menuOProgramu
		// 
		menuOProgramu.Text = "O programu";
		menuOProgramu.Click += new System.EventHandler(menuOProgramu_Click);
		// 
		// Okno1
		// 
		ClientSize = new System.Drawing.Size(424, 165);
		Controls.AddRange(new Control[] {tlatko, npis});
		Menu = Nabdka;
		Text = "Politick heslo";
		Closing += new System.ComponentModel.CancelEventHandler(this.Okno1_Closing);
		ResumeLayout(false);

	}
	#endregion

	private void zobraz()
	{
		npis.Text = jeToZatek ? zatek : konec;
		jeToZatek = !jeToZatek;
	}
	
	private void tlatko_Click(object sender, System.EventArgs e)
	{
		zobraz();
		tlatko.Text = jeToZatek ? "Zatek" : "Dokonen";
	}

	private void menuKonec_Click(object sender, System.EventArgs e)
	{
		Close();
	}

	private void menuNov_Click(object sender, System.EventArgs e)
	{
		no.PrvnNpis = zatek;
		no.DruhNpis = konec;
		if(no.ShowDialog(this) == DialogResult.OK)
		{
			zatek = no.PrvnNpis;
			konec = no.DruhNpis;
			this.jeToZatek = !this.jeToZatek;
			zobraz();
		}
		
	}

	private void menuOProgramu_Click(object sender, System.EventArgs e)
	{
		MessageBox.Show("Dvoudln politick heslo", "O programu", MessageBoxButtons.OK, 					MessageBoxIcon.Information);
	}

	private void Okno1_Closing(object sender, System.ComponentModel.CancelEventArgs e)
	{
		if(MessageBox.Show("Opravdu chce skonit?", "Dotaz", MessageBoxButtons.YesNo, 						MessageBoxIcon.Question) ==
			DialogResult.No) e.Cancel = true;
	}
}

public class Program
{
	static void Main() 
	{
		Application.Run(new Okno1());
	}

}